import { useId as R, useRef as a, useReducer as _, useEffect as E } from "react";
import { jsx as C } from "react/jsx-runtime";
import D from "clsx";
function M(e) {
  const n = R();
  if (!e)
    return n;
  if (typeof e == "number" || typeof e == "string")
    return `${e}${n}`;
  if (typeof e == "object") {
    const { id: t, prefix: o = "" } = e;
    return typeof t == "number" || typeof t == "string" ? `${o}${t}` : `${o}${n}`;
  }
}
const m = "SET_ANNOUNCEMENT", s = "CLEAR_ANNOUNCEMENT", I = {
  alert: null,
  alertdialog: null,
  log: "polite",
  marquee: null,
  progressbar: null,
  status: "polite",
  timer: "assertive"
}, v = (e, n) => {
  switch (n == null ? void 0 : n.type) {
    case m:
      return {
        ...e,
        announcement: n.payload
      };
    case s:
      return {
        ...e,
        announcement: null
      };
    default:
      return e;
  }
}, N = ({
  onAnnouncementClear: e,
  dispatch: n
}) => {
  n({
    type: s
  }), typeof e == "function" && e();
}, i = ({
  children: e,
  clearAnnouncementDelay: n,
  clearAnnouncementTimeoutRef: t,
  onAnnouncementClear: o,
  dispatch: c
}) => {
  (t == null ? void 0 : t.current) !== null && clearTimeout(t.current), e !== null && c({
    type: m,
    payload: e
  }), n && (t.current = setTimeout(
    () => N({
      onAnnouncementClear: o,
      dispatch: c
    }),
    n
  ));
}, b = ({
  children: e,
  announcementTimeoutRef: n,
  announcementDelay: t,
  clearAnnouncementDelay: o,
  clearAnnouncementTimeoutRef: c,
  onAnnouncementClear: r,
  dispatch: l
}) => {
  clearTimeout(n.current), t ? n.current = setTimeout(i, t, {
    children: e,
    clearAnnouncementDelay: o,
    clearAnnouncementTimeoutRef: c,
    onAnnouncementClear: r,
    dispatch: l
  }) : i({
    children: e,
    clearAnnouncementDelay: o,
    clearAnnouncementTimeoutRef: c,
    onAnnouncementClear: r,
    dispatch: l
  });
};
function U({
  children: e,
  className: n,
  politeness: t,
  role: o = null,
  announcementDelay: c,
  clearAnnouncementDelay: r,
  onAnnouncementClear: l,
  visible: p,
  ...f
}) {
  const d = a(), A = a(), [y, T] = _(v, {
    announcement: null
  });
  let u = t;
  typeof u > "u" && (u = o ? I[o] : "assertive"), E(() => {
    b({
      announcementTimeoutRef: d,
      announcementDelay: c,
      children: e,
      clearAnnouncementDelay: r,
      clearAnnouncementTimeoutRef: A,
      onAnnouncementClear: l,
      dispatch: T
    });
  }, [
    e,
    c,
    r,
    l
  ]);
  const h = D(n, {
    "sr-only": !p
  });
  return /* @__PURE__ */ C(
    "div",
    {
      "aria-live": u,
      ...o && { role: o },
      className: h,
      ...f,
      children: y.announcement
    }
  );
}
/*!
  @versini/ui-private v1.3.1
  © 2024 gizmette.com
*/
try {
  window.__VERSINI_UI_PRIVATE__ || (window.__VERSINI_UI_PRIVATE__ = {
    version: "1.3.1",
    buildTime: "03/11/2024 10:30 AM EDT",
    homepage: "https://github.com/aversini/ui-components",
    license: "MIT"
  });
} catch {
}
export {
  M as i,
  U as j
};
