import { jsxs as L, jsx as n } from "react/jsx-runtime";
import { i as R, j as _ } from "../../chunks/index.CPFmZDjl.js";
import A, { useRef as P, useState as S, useLayoutEffect as $ } from "react";
import { TEXT_INPUT_WRAPPER_CLASSNAME as j, r as X, TEXT_INPUT_CLASSNAME as m, TEXT_INPUT_HELPER_TEXT_CLASSNAME as F } from "../../chunks/constants.D-rfPeOH.js";
import a from "clsx";
const U = ({
  mode: t
}) => a({
  "bg-surface-darker text-copy-lighter caret-copy-light": t === "dark",
  "bg-surface-lighter text-copy-dark caret-copy-dark": t === "light",
  "bg-surface-lighter text-copy-dark caret-copy-dark dark:bg-surface-darker dark:text-copy-lighter dark:caret-copy-light": t === "system",
  "bg-surface-darker text-copy-lighter caret-copy-light dark:bg-surface-lighter dark:text-copy-dark dark:caret-copy-dark": t === "alt-system"
}), H = ({
  focusMode: t,
  error: s
}) => s ? "focus:outline focus:outline-2 focus:outline-focus-error-dark" : a("focus:outline focus:outline-2 focus:outline-offset-2", {
  "focus:outline-focus-dark": t === "dark",
  "focus:outline-focus-light": t === "light",
  "focus:outline-focus-light dark:focus:outline-focus-dark": t === "alt-system",
  "focus:outline-focus-dark dark:focus:outline-focus-light": t === "system"
}), W = ({
  noBorder: t,
  error: s
}) => a("border-2", {
  "border-border-dark": !t,
  "border-transparent": t,
  "border-border-error-dark": s
}), D = ({
  disabled: t,
  raw: s,
  error: e,
  mode: r
}) => s ? "" : a("absolute cursor-text font-medium", {
  "text-copy-lighter": !e && r === "dark",
  "text-copy-dark": !e && r === "light",
  "text-copy-dark dark:text-copy-lighter": !e && r === "system",
  "text-copy-lighter dark:text-copy-dark": !e && r === "alt-system",
  "cursor-not-allowed opacity-50": t
}), M = ({
  error: t,
  raw: s,
  mode: e
}) => s ? void 0 : a(F, "absolute px-2 font-medium", {
  "rounded-md bg-surface-darker text-copy-error-light": t,
  "text-copy-lighter": !t && e === "dark",
  "text-copy-dark": !t && e === "light",
  "text-copy-dark dark:text-copy-lighter": !t && e === "system",
  "text-copy-lighter dark:text-copy-dark": !t && e === "alt-system"
}), q = ({
  className: t,
  inputClassName: s,
  raw: e,
  disabled: r,
  noBorder: c,
  error: o,
  spacing: g,
  mode: u,
  focusMode: y
}) => {
  const f = e ? t : a(
    "relative flex w-full flex-col justify-center",
    j,
    t,
    X(g)
  ), h = e ? a(s) : a(
    m,
    s,
    "h-12 rounded-md px-4 text-base",
    U({ mode: u }),
    H({ focusMode: y, error: o }),
    W({ noBorder: c, error: o }),
    {
      "disabled:cursor-not-allowed disabled:opacity-50": r
    }
  ), x = e ? void 0 : "sr-only", k = D({
    disabled: r,
    raw: e,
    error: o,
    mode: u
  }), l = M({
    error: o,
    raw: e,
    mode: u
  });
  return {
    wrapper: f,
    input: h,
    accessibleLabel: x,
    visibleLabel: k,
    helperText: l,
    rightElement: e ? void 0 : "absolute right-3"
  };
}, z = A.forwardRef(
  ({
    id: t,
    name: s,
    label: e,
    error: r = !1,
    raw: c = !1,
    className: o,
    inputClassName: g,
    mode: u = "system",
    focusMode: y = "system",
    disabled: f = !1,
    noBorder: h = !1,
    labelId: x,
    type: k = "text",
    helperText: l = "",
    rightElement: d,
    spacing: T,
    ...I
  }, E) => {
    const b = P(null), [v, N] = S(0), p = R({ id: t, prefix: `${m}-` }), C = `${s} error, ${l}`, i = q({
      className: o,
      inputClassName: g,
      error: r,
      raw: c,
      focusMode: y,
      disabled: f,
      noBorder: h,
      spacing: T,
      mode: u
    });
    return $(() => {
      b.current && N(b.current.offsetWidth + 18 + 10);
    }, [d]), /* @__PURE__ */ L("div", { className: i.wrapper, children: [
      /* @__PURE__ */ n(
        "label",
        {
          htmlFor: p,
          id: x,
          className: i.accessibleLabel,
          children: e
        }
      ),
      /* @__PURE__ */ n(
        "input",
        {
          ref: E,
          id: p,
          name: s,
          type: k,
          disabled: f,
          placeholder: c ? void 0 : " ",
          className: i.input,
          ...l && { "aria-describedby": `${p}-helper` },
          ...r && { "aria-invalid": "true" },
          ...d && !c && { style: { paddingRight: v } },
          ...I
        }
      ),
      !c && /* @__PURE__ */ n(
        "label",
        {
          "aria-hidden": !0,
          htmlFor: p,
          className: i.visibleLabel,
          children: e
        }
      ),
      l && /* @__PURE__ */ n(
        "div",
        {
          id: `${p}-helper`,
          className: i.helperText,
          children: l
        }
      ),
      d && /* @__PURE__ */ n(
        "div",
        {
          ref: b,
          className: i.rightElement,
          children: d
        }
      ),
      r && l && /* @__PURE__ */ n(_, { politeness: "polite", clearAnnouncementDelay: 500, children: C })
    ] });
  }
);
z.displayName = "TextInput";
export {
  z as TextInput
};
